local function filter(self, event, msg, author, ...)
	--the only toast we care about is FRIEND_ONLINE
	if msg ~= "FRIEND_ONLINE" then
		return false, msg, author, ...
	end
	
	local presenceID, givenName, surname, toonName, toonID, client, fullName
	local type = strsub(event, 10)
	local info = ChatTypeInfo[type]
	
	--arg11 seems to be the presenceID, need more testing to confirm it matches the return from BNGetFriendInfo
	local arg11 = select(9, ...)
	
	--loop through the BNet friends to determine the toon name
	for i = 1, BNGetNumFriends() do
		presenceID, givenName, surname, toonName, toonID, client = BNGetFriendInfo(i)
		fullName = givenName.." "..surname
		--double check the client too, this will prevent strangeness when SC2 is released
		if client == "WoW" and author == fullName then
			--construct the playerlink and message prefix seperately for easier debugging
			local playerlink = string.format("|HBNplayer:%s:%s:%s:%s:%s|h[%s]|h", author, 7, arg11, Chat_GetChatCategory(type), 0, author)
			local prefix = string.format(BN_INLINE_TOAST_FRIEND_ONLINE, playerlink)
			--add a message to the passed in chat frame that looks like the regular toast
			self:AddMessage(string.format("%s (%s)", prefix, toonName), info.r, info.g, info.b, info.id)
			
			--block the acual toast, it is replaced with our own
			return true, msg, author, ...
			
		--if the client is anything but WoW just return the real name
		elseif author == fullName then
			return false, msg, author, ...
		end
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_INLINE_TOAST_ALERT", filter)
